<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>C Programming - Variables</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">
                    <section>
                        <h1>Variables</h1>
                        <aside class="notes">
                            This is a section title
                        </aside>
                    </section>

                    <section>
                        <h2>In This Section:</h2>
                        <ul>
                            <li>Coding Style Guide</li>
                            <li>Variable Names</li>
                            <li>Data Types</li>
                            <li>Sizes</li>
                            <li>Declarations</li>
                            <li>Initialization</li>
                            <li>Keywords</li>
                            <li>Type Conversions</li>
                        </ul>
                    </section>

                    <section>
                        <h2>By the end of this section you will learn:</h2>
                        <ul>
                            <li>How to utilize variables</li>
                            <li>Declare Variables</li>
                            <li>Initialize Variables</li>
                            <li>Determine appropriate data types</li>
                            <li>Find the size of a variable in memory</li>
                            <li>Perform Type Conversions</li>
                        </ul>
                    </section>
                    <section><h2><a href=../objectives.html>Objectives</a></h2></section>
				</section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
		    	data-background-position="top 5% left 5%">
                    <section>
                        <h1>Coding Style Guide</h1>
                    </section>

                  <!-- <section>

                        This extra overview section is not necessary-->

                        <!-- <h2>Overview</h2>       
                        <ol>
                            <li>Comments</li>
                            <ul>
                                <li>Documentation Box</li>
                                <li>Comments for each Function</li>
                                <li>Variable Declarations</li>
                            </ul>
                            <li>Variable Names</li>
                            <li>Indents & Braces</li>
                            <li>Filenames</li>
                        </ol>
                    </section> 
                -->
                    <section>
                        <h2>Documentation Box</h2>
                        <ul>
                            <li>Explains the purpose of the program</li>
                            <li>Contains name, date, and project title</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Documentation Box - Example</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
/* this program does something!
*
*  name: dwight eisenhower
*  date: 18 AUG 2020
*  project: super hard project
*
*  additional things
*/</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Function Declaration</h2>
                        <ul>
                            <li>Explain the purpose</li>
                            <li>Explain arguments</li>
                            <li>Explain return values</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Variable Declaration</h2>
                        <p>There should be a comment on each variable like this:</p>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">// Health keeps track of how much health the player has remaining
int health;</span></code></pre>
                    </section>

                    <section>
                        <h2>Names</h2>
                        <ul>
                            <li><b>Global Variables & Functions:</b> as descriptive as comments</li>
                            <li><b>Local Variables:</b> Can be shorter, but limit abbreviations</li>
                            <li>Reserve Uppercase names for macros and enums</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Indents & Braces</h2>
                        <p>Consistancy is key</p>
                    </section>

                    <section>
                        <h2>Filenames</h2>
                        <ul>
                            <li>Correct File Extensions</li>
                            <li>Lowercase only</li>
                            <li>Cannot begin with a number</li>
                        </ul>
                    </section>

                    <section>
                        <h2>More Info</h2>
                        <p>See the GNU C Styleguide <a href=https://www.gnu.org/prep/standards/html_node/Writing-C.html>here</a>.</p>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">
                    <section>
                        <h1>Variable Names</h1>
                    </section>

                    <section>
                        <h2>What <b>is</b> a variable?</h2>
                        <p>Variables are a name given to a place in the computer's memory for storing a value for our program.</p>
                    </section>
                    
                    <section>
                        <h2>Variable Name Rules</h2>
                        <ul>
                            <li>Describe the variable as best as possible</li>
                            <li>Can be composed of letters and digits only</li>
                            <li>Underscore "_" counts as a letter</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Variable Name Rules Cont.</h2>
                        <ul>
                            <li>May not begin with a number</li>
                            <li>May not be a reserved keyword</li>
                            <li>May not contain spaces</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Variable Names Examples</h2>
                        <img src="../../assets/VarNames.png" alt="Variable names">
                    </section>

                    <section>
                        <h2>Are these good variables? Why/Why not?</h2>
                        <ol>
                            <li>distanceRan</li>
                            <li>variable2</li>
                            <li>5MinTotal</li>
                            <li>_important_</li>
                            <li>video length</li>
                            <li>meters/second</li>
                        </ol>
                    </section>

                    <section>
                        <h2>Are these good variables? Why/Why not?</h2>
                        <ol>
                            <li>Yes</li>
                            <li>Yes, but should be more descriptive</li>
                            <li>No, it starts with a number</li>
                            <li>Yes, but don't start with underscore</li>
                            <li>No, it contains a space</li>
                            <li>No, / is neither a letter nor a number</li>
                        </ol>
                    </section>

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">
                    <section>
                        <h1>Data Types</h1>
                    </section>

                    <section>
                        <h2>Data Types are</h2>
                        <p>... used to interpret the binary value stored in memory.</p>
                    </section>

                    <section>
                        <h2>C Predefined Data Types</h2>
                        <ul>
                            <li>ints</li>
                            <li>chars</li>
                            <li>floats</li>
                            <li>doubles</li>
                            <li>void</li>
                        </ul>
                    </section>
                    
					<section>
						<h2>Integer</h2>
						<p>A positive or negative whole number</p>
						<ul>
							<li>Either two or four bytes, depending on complier</li>
							<li>Two bytes: [(-32,768) to (32,767)]</li>
							<li>Four bytes: [(-2,147,483,648) to (2,147,483,647)]</li>
						</ul>
						<aside class="notes">
							Add notes here.
						</aside>
					</section>

					<section>
						<h2>Char</h2>
						<p>Stores a single character</p>
						<ul>
							<li>One byte</li>
							<li>In the background, it is an integer type</li>
							<li>Can be signed or unsigned</li>
						</ul>
						<aside class="notes">
							Add notes here.
						</aside>
					</section>

					<section>
						<h2>Floating Point</h2>
						<p>A single-precision decimal number</p>
						<ul>
							<li>Four bytes</li>
							<li>Value Range of 1.2E-38 to 3.4E+38</li>
							<li>Precision of 6 decimal points</li>
						</ul>
						<aside class="notes">
							Add notes here.
						</aside>
					</section>

					<section>
						<h2>Double</h2>
						<p>A double float</p>
						<ul>
							<li>Eight bytes</li>
							<li>Value Range of 2.2E-308 to 1.7E+308</li>
							<li>Precision of 15 decimal points</li>
						</ul>
						<aside class="notes">
							Add notes here.
						</aside>
                    </section>

                    <section>
                        <h2>Void</h2>
                        <p>No Data</p>
                    </section>
                    

                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">
                    <section>
                        <h1>Demonstration Lab</h1>
                        <aside class="notes">
                            https://39iosdev.gitlab.io/ccd-iqt/idf/C-Programming/Variables/Data_types.html
                        </aside>
                    </section>

				    <section>
					    <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
#include &ltstdio.h&gt

int main(void)
{
	int integer = 1;
	float singlePrecision = 2.2;
	double doublePrecision = 3.3;
	char singleChar = '$';
	char singleChar2 = 33;

	printf("your integer is %d \n", integer);
	printf("your float is %f \n", singlePrecision);
	printf("your double is %lf \n", doublePrecision);
	printf("your first char is %c \n", singleChar);
	printf("your second char is %c \n", singleChar2);  

	return 0;
}
</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Questions:</h2>
                        <ol>
                            <li>Which data types were used?</li>
                            <li>What happened when we printed char 33?</li>
                        </ol>
                    </section>
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">

                    <section>
                        <h1>Data Size</h1>
                    </section>

                    <section>
                        <h2>Data Size - Why does it matter?</h2>
                        <aside class="notes">
                            Size sets limits on the information that can be stored. 
                            Computers have a finite amount of free memory. 
                        </aside>
                    </section>

                    <section>
                        <h3>C puts YOU - The Programmer - in control of the memory</h3>
                        <aside class="notes">
                            Double-Edged sword
                            It's easy to create memory leaks and such if not careful.
                            Gives the programmer the power to program on devices where minimal memory usage may be necessary.
                        </aside>
                    </section>

                    <section>
                        <h2>sizeof()</h2>
                        <p><b>sizeof()</b> is used to determine the amount of memory taken up. <b>Never guess</b>; let the system tell us.</p>
                        <aside class="notes">
                            Next slide is a demonstration
                        </aside>
                    </section>
                
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">

                    <section>
                        <h1>Demonstration Lab</h1>
                        <aside class="notes">
                            https://39iosdev.gitlab.io/ccd-iqt/idf/C-Programming/Variables/Sizes.html
                        </aside>
                    </section>

				    <section>
					<div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
#include &ltstdio.h&gt

int main(void)
{
	int integer = 1;
	float singlePrecision = 2.2;
	double doublePrecision = 3.3;
	char singleChar = '$';
	char singleChar2 = 33;

	printf("size of int is %d \n", sizeof(integer));
	printf("size of float is %d \n", sizeof(singlePrecision));
	printf("size of double is %d \n", sizeof(doublePrecision));
	printf("size of char 1 is %d \n", sizeof(singleChar));
	printf("size of char 2 is %d \n", sizeof(singleChar2));

	return 0;
}</code></pre></div></div>
                    </section>

                    <section>
                        <h2>Questions</h2>
                        <ol>
                            <li>Was there a difference between singleChar and singleChar2?</li>
                            <li>Why do you think we changed our print statement to %d? (hint: Look at previous demonstration)</li>
                        </ol>
                    </section>
                
                </section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">

                    <section>
                        <h2>Variable Declaration & Initialization</h2>
                    </section>

                    <section>
                        <h2>Variable Declarations</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int main(void)
{
	/********** VARIABLE DECLARATION **********/
	/* Syntax: DATA_TYPE VARIABLE_NAME; */

	int lowerLimit;    // lowest y value for graph
	int upperLimit;    // highest y value for graph
	float x, y;        // graphing function variables

	// used to hold a person's individual initials
	char firstInitial, middleInitial, lastInitial;
	double pi;        // stores the constant "pi"
	return 0;
}</code></pre></div></div>
					    <aside class="notes">
						    A declaration determines the interpretation and properties of one or more identifiers. 
						    A declaration that allocates storage space for an object or a function is a definition. 
						    Multiple variables of the same data type can be declared in a single statement. 
						    Declaration alone does not 'implicitly' zeroize a variable. That comes later with initialization.
						    NOTE: all variables must be declared before use! 
					    </aside>
				    </section>

				    <section>
					    <h2>Variable Initialization</h2>
					    <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
int main(void)
{
	/******** VARIABLE INITIALIZATION ********/

	int finalResult;
	/* initialization syntax...
	DATA_TYPE VARIABLE_NAME = INITAL_VALUE; */

	int lowerLimit = -10;    // lowest y value for grahp
	int upperLimit = 10;     // highest y value for graph
	float x = 1.0, y = 2.1;  // graphing variables 

	// used to hold a person's individual initials
	char firstInit = 'C', middleInit = 'M', lastInit = '';

	double pi = 3.14159265359;    // stores the constant "pi"
	finalResult = 0;    // placeholder 0. to be changed later.

	return finalResult;
}</code></pre></div></div>
					    <aside class="notes">
					    	It is very important that you initialize a variable after declaring it. This simply means assigning it a value of some sort.
						    Failure to assign a value to the variable could result in one being assigned by your IDE, or worse, 
						    you'll end up with something you do not want. Think of it this way. 
						    By declaring a variable, you have allocated a chunk of memory for those variables. By not initializing your variable, 
						    your values could be valid or not, based on what could have been assigned to that memory location previously etc.
					    </aside>
				    </section>

                    <section>
                        <img src="../../assets/817d317eecb8af559b39be77577c2b2e--engineer-humor-computer-jokes.jpg" alt="I see variables">
                    </section>
                
                </section>

                <section>
					<h2> Performance Lab</h2>
					<aside class="notes">
						Notes go here.
					</aside>
				</section>

				<section>
					<h2>Keywords</h2>
					<p>Keywords are reserved words used in a programming language.</p>
					<p>A list of C keywords is available <a href="https://en.cppreference.com/w/c/keyword">here</a>.</p>
					<aside class="notes">
						No notes here
					</aside>
				</section>

                <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">

                    <section>
                        <h1>Type Conversions</h1>
                    </section>

                    <section>
                        <h2>What is it?</h2>
                        <p>Type conversion changes the data type of a variable.</p>
                    </section>

                    <section>
                        <h2>Example</h2>
                        <p>You can convert a double to a float, but the may round data if nessessary to make the data fit into a float</p>
                    </section>

                    <section>
                        <h2>Example Code</h2>
                        <div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// pseudocode example
(data_type) expression // not everything can be type cast

// stub example
(double) 15 / 3 //result is int yet 'coerced as double

// full example
#include &ltstdio.h&gt

int main(void)
{
    int grade1 = 90, grade 2 = 100;    // student grades
    double gradeAvg = 0;               // student average
    gradeAvg = (double) ((grade1 + grade2) / 2);
    return 0;
}</code></pre></div></div>
                </section>
            
            </section>

            <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">
                <section>
                    <h1>Performance Lab</h1>
                </section>

                <section>
                    <h2>Review labs demo 2a & 2b, and Practice the following tasks</h2>
                </section>

                <section>
                    <h2>Declare and initialize variables of data types: </h2>
                    <ul>
                        <li>int</li>
                        <li>float</li>
                        <li>double</li>
                        <li>char</li>
                    </ul>
                    <p>NOTE: For this lab, please initialize your int to a value between 32 and 126</p>
                </section>

                <section>
                    <h2>Typecast and print the following</h2>
                    <ul>
                        <li>int -> float</li>
                        <li>int -> char</li>
                        <li>float -> double</li>
                        <li>double -> float</li>
                        <li>char -> int</li>
                        <li>63 -> char</li>
                    </ul>
                </section>

            </section>

            <section data-background-image="images/org_symbol.png" data-background-size="8%"
                data-background-position="top 5% left 5%">
                    <section>
                        <h1>Questions?</h1>
                        <aside class="notes">
                            This is a section title
                        </aside>
                    </section>

                    <section>
                        <h2>In This Section:</h2>
                        <ul>
                            <li>Coding Style Guide</li>
                            <li>Variable Names</li>
                            <li>Data Types</li>
                            <li>Sizes</li>
                            <li>Declarations</li>
                            <li>Initialization</li>
                            <li>Keywords</li>
                            <li>Type Conversions</li>
                        </ul>
                    </section>

                    <section>
                        <h2>By the end of this section you should:</h2>
                        <ul>
                            <li>How to utilize variables</li>
                            <li>Declare Variables</li>
                            <li>Initialize Variables</li>
                            <li>Determine appropriate data types</li>
                            <li>Find the size of a variable in memory</li>
                            <li>Perform Type Conversions</li>
                        </ul>
                    </section>

                </section>
                
        </div>
    </div>
    <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
        <div style="text-align: center;">(U)Unclassified</div>
    </footer>	
        
        
    <script src="js/reveal.js"></script>

    <script>
        // More info about config & dependencies:
        // - https://github.com/hakimel/reveal.js#configuration
        // - https://github.com/hakimel/reveal.js#dependencies
        Reveal.initialize({
            hash: true,
            menu: {
                // Specifies which side of the presentation the menu will 
                // be shown. Use 'left' or 'right'.
                side: 'left',

                // Specifies the width of the menu.
                // Can be one of the following:
                // 'normal', 'wide', 'third', 'half', 'full', or
                // any valid css length value
                width: 'normal',

                // Add slide numbers to the titles in the slide list.
                // Use 'true' or format string (same as reveal.js slide numbers)
                numbers: true,

                // Specifies which slide elements will be used for generating
                // the slide titles in the menu. The default selects the first
                // heading element found in the slide, but you can specify any
                // valid css selector and the text from the first matching
                // element will be used.
                // Note: that a section data-menu-title attribute or an element
                // with a menu-title class will take precedence over this option
                titleSelector: 'h1, h2, h3, h4, h5, h6',

                // If slides do not have a matching title, attempt to use the
                // start of the text content as the title instead
                useTextContentForMissingTitles: false,

                // Hide slides from the menu that do not have a title.
                // Set to 'true' to only list slides with titles.
                hideMissingTitles: false,

                // Adds markers to the slide titles to indicate the 
                // progress through the presentation. Set to 'false'
                // to hide the markers.
                markers: true,

                // Specify custom panels to be included in the menu, by
                // providing an array of objects with 'title', 'icon'
                // properties, and either a 'src' or 'content' property.
                custom: false,

                // Specifies the themes that will be available in the themes
                // menu panel. Set to 'true' to show the themes menu panel
                // with the default themes list. Alternatively, provide an
                // array to specify the themes to make available in the
                // themes menu panel, for example...
                // [
                //     { name: 'Black', theme: 'css/theme/black.css' },
                //     { name: 'White', theme: 'css/theme/white.css' },
                //     { name: 'League', theme: 'css/theme/league.css' }
                // ]
                themes: true,

                // Specifies the path to the default theme files. If your
                // presentation uses a different path to the standard reveal
                // layout then you need to provide this option, but only
                // when 'themes' is set to 'true'. If you provide your own 
                // list of themes or 'themes' is set to 'false' the 
                // 'themesPath' option is ignored.
                themesPath: 'css/theme/',

                // Specifies if the transitions menu panel will be shown.
                // Set to 'true' to show the transitions menu panel with
                // the default transitions list. Alternatively, provide an
                // array to specify the transitions to make available in
                // the transitions panel, for example...
                // ['None', 'Fade', 'Slide']
                transitions: true,

                // Adds a menu button to the slides to open the menu panel.
                // Set to 'false' to hide the button.
                openButton: true,

                // If 'true' allows the slide number in the presentation to
                // open the menu panel. The reveal.js slideNumber option must 
                // be displayed for this to take effect
                openSlideNumber: true,

                // If true allows the user to open and navigate the menu using
                // the keyboard. Standard keyboard interaction with reveal
                // will be disabled while the menu is open.
                keyboard: true,

                // Normally the menu will close on user actions such as
                // selecting a menu item, or clicking the presentation area.
                // If 'true', the sticky option will leave the menu open
                // until it is explicitly closed, that is, using the close
                // button or pressing the ESC or m key (when the keyboard 
                // interaction option is enabled).
                sticky: true,

                // If 'true' standard menu items will be automatically opened
                // when navigating using the keyboard. Note: this only takes 
                // effect when both the 'keyboard' and 'sticky' options are enabled.
                autoOpen: true,

                // If 'true' the menu will not be created until it is explicitly
                // requested by calling RevealMenu.init(). Note this will delay
                // the creation of all menu panels, including custom panels, and
                // the menu button.
                delayInit: false,

                // If 'true' the menu will be shown when the menu is initialised.
                openOnInit: false,

                // By default the menu will load it's own font-awesome library
                // icons. If your presentation needs to load a different
                // font-awesome library the 'loadIcons' option can be set to false
                // and the menu will not attempt to load the font-awesome library.
                loadIcons: true
            },
            dependencies: [
                { src: 'plugin/markdown/marked.js' },
                { src: 'plugin/markdown/markdown.js' },
                { src: 'plugin/highlight/highlight.js' },
                { src: 'plugin/notes/notes.js', async: true },
                { src: 'plugin/reveal.js-menu/menu.js' }
            ]
        });
    </script>
</body>
</html>
